package com.fastcashier.lib_common.function.print

import com.fastcashier.lib_common.base.BaseBean
import com.fastcashier.lib_common.function.print.ViewOrderStatisticsInfo.StatisticBean
import com.sdy.miya.moblie.component.pay.platform.bean.BaseDO
import com.sdy.miya.moblie.component.pay.platform.bean.QueryTradesByTimeResponse
import com.fastcashier.lib_common.function.print.ViewOrderStatisticsInfo
import android.text.TextUtils
import java.math.BigDecimal
import java.util.ArrayList

/**
 * 类描述：基础统计数据类
 * 概述：仅用于打印的数据信息模型
 * 创建人：zpxiang
 * 创建时间：2022/6/1
 * 修改人：
 * 修改时间：
 */
class ViewOrderStatisticsInfo : BaseBean() {
    var beginDate: String? = null
    var endDate: String? = null
    private var totalStatistic: StatisticBean? = null
    private var typeStatistic: MutableList<StatisticBean>? = null


    fun getTotalStatistic(): StatisticBean? {
        return totalStatistic
    }

    fun setTotalStatistic(totalStatistic: StatisticBean?) {
        this.totalStatistic = totalStatistic
    }

    fun getTypeStatistic(): List<StatisticBean>? {
        return typeStatistic
    }

    fun setTypeStatistic(typeStatistic: MutableList<StatisticBean>?) {
        this.typeStatistic = typeStatistic
    }

    class StatisticBean : BaseDO() {
        /**
         * 支付方式
         */
        var payType: String? = null

        /**
         * 交易笔数
         */
        var tradeCount = 0

        /**
         * 交易总金额
         */
        var tradeTotalAmount = 0

        /**
         * 退款笔数
         */
        var refundCount = 0

        /**
         * 退款总金额
         */
        var refundTotalAmount = 0

        /**
         * 商户优惠
         */
        var merchantDiscount = 0

        /**
         * 平台优惠
         */
        var platformDiscount = 0

        /**
         * 退款商户优惠
         */
        var refundMerchantDiscount = 0

        /**
         * 退款平台优惠
         */
        var refundPlatformDiscount = 0

        @JvmName("getPayType1")
        fun getPayType(): String? {
            return payType
        }

        @JvmName("setPayType1")
        fun setPayType(payType: String?) {
            this.payType = payType
        }

        @JvmName("getTradeCount1")
        fun getTradeCount(): Int {
            return tradeCount
        }

        @JvmName("setTradeCount1")
        fun setTradeCount(tradeCount: Int) {
            this.tradeCount = tradeCount
        }

        @JvmName("getTradeTotalAmount1")
        fun getTradeTotalAmount(): Int {
            return tradeTotalAmount
        }

        @JvmName("setTradeTotalAmount1")
        fun setTradeTotalAmount(tradeTotalAmount: Int) {
            this.tradeTotalAmount = tradeTotalAmount
        }

        @JvmName("getRefundCount1")
        fun getRefundCount(): Int {
            return refundCount
        }

        @JvmName("setRefundCount1")
        fun setRefundCount(refundCount: Int) {
            this.refundCount = refundCount
        }

        @JvmName("getRefundTotalAmount1")
        fun getRefundTotalAmount(): Int {
            return refundTotalAmount
        }

        @JvmName("setRefundTotalAmount1")
        fun setRefundTotalAmount(refundTotalAmount: Int) {
            this.refundTotalAmount = refundTotalAmount
        }

        @JvmName("getMerchantDiscount1")
        fun getMerchantDiscount(): Int {
            return merchantDiscount
        }

        @JvmName("setMerchantDiscount1")
        fun setMerchantDiscount(merchantDiscount: Int) {
            this.merchantDiscount = merchantDiscount
        }

        @JvmName("getPlatformDiscount1")
        fun getPlatformDiscount(): Int {
            return platformDiscount
        }

        @JvmName("setPlatformDiscount1")
        fun setPlatformDiscount(platformDiscount: Int) {
            this.platformDiscount = platformDiscount
        }

        @JvmName("getRefundMerchantDiscount1")
        fun getRefundMerchantDiscount(): Int {
            return refundMerchantDiscount
        }

        @JvmName("setRefundMerchantDiscount1")
        fun setRefundMerchantDiscount(refundMerchantDiscount: Int) {
            this.refundMerchantDiscount = refundMerchantDiscount
        }

        fun getRefundPlatformDiscount(): Int? {
            return refundPlatformDiscount
        }

        @JvmName("setRefundPlatformDiscount1")
        fun setRefundPlatformDiscount(refundPlatformDiscount: Int) {
            this.refundPlatformDiscount = refundPlatformDiscount
        }
    }

    companion object {
        fun transfer(
            queryTradesByTimeResponse: QueryTradesByTimeResponse,
            beginDate: String?,
            endDate: String?
        ): ViewOrderStatisticsInfo {
            val statisticsInfo = ViewOrderStatisticsInfo()
            statisticsInfo.beginDate = beginDate
            statisticsInfo.endDate = endDate
            if (!TextUtils.isEmpty(queryTradesByTimeResponse.billInformation)) {
                val billInformation = queryTradesByTimeResponse.billInformation
                val serial = billInformation.split(";".toRegex()).toTypedArray()
                if (serial.size > 0) {
                    statisticsInfo.typeStatistic = ArrayList()
                    for (i in serial.indices) {
                        if (!TextUtils.isEmpty(serial[i])) {
                            val values = serial[i].split(",".toRegex()).toTypedArray()
                            val statisticBean = StatisticBean()
                            for (j in values.indices) {
                                valueToField(statisticBean, values[j], j)
                            }
                            (statisticsInfo.typeStatistic as ArrayList<StatisticBean>).add(statisticBean)
                        }
                    }
                }
            }
            statisticsInfo.totalStatistic = StatisticBean()
            statisticsInfo.totalStatistic!!.payType = null
            statisticsInfo.totalStatistic!!.tradeCount = queryTradesByTimeResponse.tradeCount
            statisticsInfo.totalStatistic!!.tradeTotalAmount =
                queryTradesByTimeResponse.tradeTotalAmount
            statisticsInfo.totalStatistic!!.refundCount = queryTradesByTimeResponse.refundCount
            statisticsInfo.totalStatistic!!.refundTotalAmount =
                queryTradesByTimeResponse.refundTotalAmount
            statisticsInfo.totalStatistic!!.merchantDiscount =
                queryTradesByTimeResponse.merchantDiscount
            statisticsInfo.totalStatistic!!.platformDiscount =
                queryTradesByTimeResponse.platformDiscount
            statisticsInfo.totalStatistic!!.refundMerchantDiscount =
                queryTradesByTimeResponse.refundMerchantDiscount
            statisticsInfo.totalStatistic!!.refundPlatformDiscount =
                queryTradesByTimeResponse.refundPlatformDiscount
            return statisticsInfo
        }

        private fun valueToField(statisticBean: StatisticBean, value: String, index: Int) {
            when (index) {
                0 -> statisticBean.payType = value
                1 -> statisticBean.tradeCount = toInt(value)
                2 -> statisticBean.tradeTotalAmount = toInt(value)
                3 -> statisticBean.refundCount = toInt(value)
                4 -> statisticBean.refundTotalAmount = toInt(value)
                5 -> statisticBean.merchantDiscount = toInt(value)
                6 -> statisticBean.platformDiscount = toInt(value)
                7 -> statisticBean.refundMerchantDiscount = toInt(value)
                8 -> statisticBean.refundPlatformDiscount = toInt(value)
            }
        }

        private fun toInt(value: String): Int {
            return if (TextUtils.isEmpty(value) && !TextUtils.isDigitsOnly(value)) {
                0
            } else BigDecimal(value).toInt()
        }
    }
}